package provide DS9 1.0

proc UpdateMagnifier {which x y} {
    global mag

    if {$mag(view)} {
	$which magnifier update $x $y
    }
}

proc ChangeMagnifierMode {} {
    global mag
    global ds9

    foreach f $ds9(frames) {
	$f magnifier mode $mag(mode)
    }
}

proc ChangeMagnifierRegion {} {
    global mag
    global ds9
    
    foreach f $ds9(frames) {
	$f magnifier graphics $mag(region)
    }
}

proc ChangeMagnifierCursor {} {
    global mag
    global ds9
    
    foreach f $ds9(frames) {
	$f magnifier cursor $mag(cursor)
    }
}

proc MagnifierZoomTo {} {
    global mag
    global ds9

    foreach f $ds9(frames) {
	$f magnifier zoom $mag(zoom)
    }
}
