#ifndef __box_h__
#define __box_h__

#include "basebox.h"

class Box : public BaseBox {
private:
  void updateHandles();

public:
  Box(const Box&);
  Box(Frame* p, const Vector& ctr, const Vector& s, double a,
      const char* clr, int w, const char* f,
      const char* t, unsigned short prop, const char* c);

  Marker* dup() {return new Box(*this);}
  void editBegin(int);
  void edit(const Vector&, int);
  void editEnd();

  Vector getSize() {return size[0].abs();}
  void setSize(const Vector&);

  void list(ostream&, CoordSystem, CoordFormat, char);
  void listCiao(ostream&, CoordSystem, CoordFormat, char);
  void listSAOtng(ostream&, CoordSystem, CoordFormat, char);
  void listSAOimage(ostream&, CoordSystem, CoordFormat, char);
  void listPros(ostream&, CoordSystem, CoordFormat, char);
};

#endif
