/* cc -g -I. -o ltest ltest.c launch.c */
#include <stdio.h>
#include <errno.h>
#include <signal.h>
#include <fcntl.h>                                                       
#include <sys/time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>                                                  
#ifdef HAVE_STRING_H
#include <string.h>
#endif
#ifdef HAVE_MALLOC_H
#include <malloc.h>
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#include <word.h>
#include <launch.h>

int main(int argc, char **argv)
{
  char *pname;
  int attach;
  int got;

  if( argc != 3 )
    exit(1);

  pname = argv[1];
  attach = atoi(argv[2]);
  got = launch(pname, attach, NULL);
  fprintf(stderr, "%s: %d\n", pname, got);
  if( !got && !attach ){
    fprintf(stderr, "killing %d\n", launchpid());
    kill(launchpid(), SIGKILL);
  }
  return 0;
}
