#ifndef __circle_h__
#define __circle_h__

#include "basecircle.h"

class Circle : public BaseCircle {
public:
  Circle(const Circle&);
  Circle(Frame* p, const Vector& ctr, double r,
	 const char* clr, int w, const char* f, 
	 const char* t, unsigned short prop, const char* c);

  Marker* dup() {return new Circle(*this);}
  void updateBBox();
  void edit(const Vector&, int);

  double getRadius() {return radii[0];}
  void setRadius(double);

  void list(ostream&, CoordSystem, CoordFormat, char);
  void listCiao(ostream&, CoordSystem, CoordFormat, char);
  void listSAOtng(ostream&, CoordSystem, CoordFormat, char);
  void listSAOimage(ostream&, CoordSystem, CoordFormat, char);
  void listPros(ostream&, CoordSystem, CoordFormat, char);
};

#endif
