#ifndef __coord_h__
#define __coord_h__

enum CoordSystem {WINDOW, CANVAS, WIDGET, USER, REF, DATA, PANNER,
		  IMAGE, PHYSICAL, AMPLIFIER, DETECTOR, 
		  EQUATORIAL_FK4, EQUATORIAL_FK5, ECLIPTIC, GALACTIC, 
		  LINEAR, ICRS, NATIVEWCS};
enum CoordFormat {PIXELS, DEGREES, SEXAGESIMAL, ARCMIN, ARCSEC};
enum Orientation {NORMAL, XX, YY, XY};

#endif
